SystemOrganization addCategory: #Halloween!
SystemOrganization addCategory: 'Halloween-Tests'!

TestCase subclass: #LegionTest
	instanceVariableNames: 'unaLegion pedro juan otraLegion unAdulto ninios'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween-Tests'!

!LegionTest commentStamp: '<historical>' prior: 0!
A LegionTest is a test class for testing the behavior of Legion!

!LegionTest methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 21:30'!
setUp
|sullivan  frankstein  cuentos  cuentos2 ninios2|
sullivan:= Tierno crearCon: 2.
frankstein:= Tradicional crearCon: 'tradicional'.
cuentos := OrderedCollection new.
cuentos add: frankstein. 
pedro:=Ninio crearCon: sullivan  dulces: 20 actitud: 15 cuentosTerror: cuentos.
cuentos2:= OrderedCollection  new.
juan:=Ninio crearCon: sullivan  dulces: 30 actitud: 25 cuentosTerror: cuentos2.
ninios:=OrderedCollection new.
ninios2:= OrderedCollection new.
ninios2 add:juan.
ninios2 add:pedro.
otraLegion := Legion crearCon: ninios2.
unAdulto:= Comun new.! !

!LegionTest methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 03:30'!
testAsustarA

^self assert: (otraLegion asustarA: unAdulto) equals: 65.


! !

!LegionTest methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:48'!
testCrearLegion

ninios add: pedro.
ninios add: juan.

unaLegion:= Legion crearCon: ninios.

self assert: unaLegion miembros size equals: 2.! !

!LegionTest methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:48'!
testNoCrearLegion

ninios add: pedro.

self assert: (unaLegion:= Legion crearCon: ninios) equals: 'No tiene suficientes ninios'! !

TestCase subclass: #NinioTest
	instanceVariableNames: 'pedro unAdulto unNecio unAbuelo juan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween-Tests'!

!NinioTest commentStamp: '<historical>' prior: 0!
A NiñoTest is a test class for testing the behavior of Niño!

!NinioTest methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 21:30'!
setUp
|sullivan frankstein  cuentos cuentos2|

sullivan:= Tierno crearCon: 2.
frankstein:= Tradicional crearCon: 'tradicional'.
cuentos := OrderedCollection new.
cuentos add: frankstein.

pedro:=Ninio crearCon: sullivan  dulces: 20 actitud: 15 cuentosTerror: cuentos.

unAdulto:= Comun new.
unNecio:= Necio new.
unAbuelo:= Abuelo new.

cuentos2:= OrderedCollection  new.
juan:=Ninio crearCon: sullivan  dulces: 30 actitud: 25 cuentosTerror: cuentos2.
! !

!NinioTest methodsFor: 'as yet unclassified' stamp: ''!
testAsustarAUnAdulto

pedro asustarA: unAdulto.
pedro asustarA: unAdulto.

self assert: pedro dulces equals: 25.! !

!NinioTest methodsFor: 'as yet unclassified' stamp: ''!
testCapacidadSusto

self assert: pedro capacidadSusto equals: 30.! !

!NinioTest methodsFor: 'as yet unclassified' stamp: ''!
testComerDulces

pedro comerDulces: 10.

self assert: pedro dulces equals: 10.

self assert: pedro actitud equals: 25. ! !

!NinioTest methodsFor: 'as yet unclassified' stamp: ''!
testContarCuento


pedro contarCuentoA: unAbuelo.
self assert: pedro dulces equals: 35.! !

!NinioTest methodsFor: 'as yet unclassified' stamp: ''!
testNoAsustarAUnAdulto

pedro asustarA: unNecio.

self assert: pedro dulces equals: 20.! !

!NinioTest methodsFor: 'as yet unclassified' stamp: ''!
testNoComerDulces

self assert: (pedro comerDulces: 30) equals: 'No tiene suficientes dulces'.
! !

!NinioTest methodsFor: 'as yet unclassified' stamp: ''!
testNoContarCuento

self assert: (juan contarCuentoA: unAbuelo) equals: 'No conoce cuento'! !

Object subclass: #Brujo
	instanceVariableNames: 'largoSombrero'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Brujo class methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 00:53'!
crearCon: largoSombrero
|unBrujo|
unBrujo:= Brujo new.
unBrujo largoSombrero: largoSombrero.
^unBrujo.! !

!Brujo methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:26'!
largoSombrero
	
	^ largoSombrero! !

!Brujo methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:26'!
largoSombrero: anObject
	
	largoSombrero := anObject! !

!Brujo methodsFor: 'as yet unclassified' stamp: 'Aldana 10/31/2015 20:27'!
nivelSusto
^(self largoSombrero/2) +10.! !

Object subclass: #Comun
	instanceVariableNames: 'niniosQueLoAsustaron'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

Comun subclass: #Abuelo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Abuelo methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 00:15'!
escucharHistoria: unaColeccionDeCuentos
^ (super escucharHistoria: unaColeccionDeCuentos ) * 3.! !

!Abuelo methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:45'!
serAsustadoPor: unNinio
^super tolerancia.! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 00:18'!
escuchar: unCuento 
|cant|
(unCuento tipo = 'tradicional') ifTrue: [cant:= 5]
							    ifFalse: [ cant:= (5 * unCuento cantPersonajes )].
							
^cant.! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 00:27'!
escucharHistoria: unaColeccionDeCuentos
^ (unaColeccionDeCuentos collect: [ :unCuento | self escuchar:  unCuento ]) sum.! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:43'!
initialize
|ninios|
ninios :=OrderedCollection new.

self niniosQueLoAsustaron: ninios.! !

!Comun methodsFor: 'accessing' stamp: 'Aldana 12/3/2015 16:44'!
niniosQueLoAsustaron
	^ niniosQueLoAsustaron! !

!Comun methodsFor: 'accessing' stamp: 'Aldana 12/3/2015 16:44'!
niniosQueLoAsustaron: anObject
	niniosQueLoAsustaron := anObject! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:44'!
niniosQueLoAsustaronMas15
^self niniosQueLoAsustaron count: [ :unNinio | unNinio dulces > 15 ].! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:45'!
serAsustadoPor: unNinio
|dulces|

dulces:=0.
(self tolerancia < unNinio capacidadSusto) ifTrue: [ dulces:= (self tolerancia /2)].

self niniosQueLoAsustaron add: unNinio.
^dulces.! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:45'!
tolerancia
^10* self niniosQueLoAsustaronMas15.! !

Object subclass: #Innovadora
	instanceVariableNames: 'personajes tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Innovadora class methodsFor: 'instance creation' stamp: 'Aldana 11/24/2015 00:55'!
crearCon: cantPersonajes tipo: tipo
 |cuentoInnovador|
cuentoInnovador := Innovadora new.
cuentoInnovador personajes: cantPersonajes.
cuentoInnovador tipo: tipo.
^cuentoInnovador.! !

!Innovadora methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 21:34'!
personajes
	
	^ personajes! !

!Innovadora methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 21:33'!
personajes: anObject
	
	personajes := anObject! !

!Innovadora methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 21:34'!
tipo
	
	^ tipo! !

!Innovadora methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 21:33'!
tipo: anObject
	
	tipo := anObject! !

Object subclass: #Legion
	instanceVariableNames: 'miembros'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Legion class methodsFor: 'as yet unclassified' stamp: 'Aldana 12/1/2015 23:25'!
agregarMiembros: niños a: unaLegion

(niños  < 2) ifTrue: [ Error signal: 'No tiene suficientes niños' ].
unaLegion miembros: niños.
^unaLegion.! !

!Legion class methodsFor: 'as yet unclassified' stamp: 'Aldana 12/1/2015 23:23'!
crearCon: niños
  |unaLegion|
unaLegion:= Legion new.
^[unaLegion agregarMiembros:niños a: unaLegion] on: Error do: [ :excep | excep messageText ].! !

!Legion methodsFor: 'accessing' stamp: 'Aldana 12/3/2015 16:46'!
agregarMiembros: coleccionNinios a: unaLegion
(coleccionNinios size  < 2) ifTrue: [ Error signal: 'No tiene suficientes ninios' ].
unaLegion miembros: coleccionNinios.

^unaLegion.! !

!Legion methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:46'!
asustarA: unAdulto
|dulces|
dulces:=0.
dulces:= miembros sum: [:unNinio | unNinio asustarA: unAdulto].

miembros do: [ :unNinio | unNinio recibirDulces: (dulces/(miembros size)) ]. 

^dulces.! !

!Legion methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:46'!
capacidadSusto

^ miembros sum: [:unNinio | unNinio capacidadSusto ].! !

!Legion methodsFor: 'as yet unclassified' stamp: 'Aldana 12/1/2015 23:51'!
initialize
|miem|
miem  :=OrderedCollection new.

self miembros: miem.! !

!Legion methodsFor: 'accessing' stamp: 'Aldana 11/24/2015 02:51'!
miembros
	^ miembros! !

!Legion methodsFor: 'accessing' stamp: 'Aldana 11/24/2015 02:51'!
miembros: anObject
	miembros := anObject! !

!Legion methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:50'!
ninioConMasActividades

^miembros detectMax: [ :unNinio | unNinio actividad ].! !

Object subclass: #Necio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Necio methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 00:15'!
escucharHistoria: unaColeccionDeCuentos
^7 * unaColeccionDeCuentos size.! !

!Necio methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 16:46'!
serAsustadoPor: unNinio

^0.! !

Object subclass: #Ninio
	instanceVariableNames: 'traje dulces actitud cuentosTerror actividad interactuados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Ninio class methodsFor: 'as yet unclassified' stamp: 'Aldana 12/3/2015 21:30'!
crearCon: traje dulces: dulces actitud: actitud cuentosTerror: cuentos 
|unNiño|
unNiño := Ninio new.
unNiño traje: traje.
unNiño dulces: dulces.
unNiño actitud: actitud.
unNiño cuentosTerror: cuentos.
unNiño actividad: 0.
^unNiño.! !

!Ninio methodsFor: 'accessing' stamp: ''!
actitud
	
	^ actitud! !

!Ninio methodsFor: 'accessing' stamp: ''!
actitud: anObject
	
	actitud := anObject! !

!Ninio methodsFor: 'accessing' stamp: ''!
actividad
	
	^ actividad! !

!Ninio methodsFor: 'accessing' stamp: ''!
actividad: anObject
	
	actividad := anObject! !

!Ninio methodsFor: 'as yet unclassified' stamp: ''!
asustarA: unAdulto
|candy|

candy:=unAdulto serAsustadoPor: self.
self recibirDulces: candy.
self interactuados add: unAdulto.

actividad:= actividad +1.

^self dulces.! !

!Ninio methodsFor: 'as yet unclassified' stamp: ''!
capacidadSusto
^(self actitud) * traje nivelSusto.! !

!Ninio methodsFor: 'accessing' stamp: ''!
comer: cantidad

(self dulces < cantidad) ifTrue: [ Error signal: 'No tiene suficientes dulces'].
self dulces: dulces- cantidad.
self actitud: actitud + cantidad.
! !

!Ninio methodsFor: 'accessing' stamp: ''!
comerDulces: cantidad
^[self comer: cantidad] on: Error do: [ :excep | excep messageText ].! !

!Ninio methodsFor: 'accessing' stamp: ''!
conoceCuentoTerror
^(self cuentosTerror size)>0.! !

!Ninio methodsFor: 'accessing' stamp: 'Aldana 12/3/2015 21:28'!
contarA: unAdulto

(self conoceCuentoTerror ) ifTrue: [ self recibirDulces:  (unAdulto escucharHistoria: cuentosTerror) ]
							ifFalse: [ Error signal: 'No conoce cuento' ].
							
actividad := actividad +1.
	! !

!Ninio methodsFor: 'accessing' stamp: ''!
contarCuentoA: unAdulto
^[self contarA: unAdulto] on: Error do: [ :excep | excep messageText  ]
! !

!Ninio methodsFor: 'accessing' stamp: ''!
cuentosTerror
	^ cuentosTerror! !

!Ninio methodsFor: 'accessing' stamp: ''!
cuentosTerror: anObject
	cuentosTerror := anObject! !

!Ninio methodsFor: 'as yet unclassified' stamp: ''!
dulces
	
	^ dulces! !

!Ninio methodsFor: 'accessing' stamp: ''!
dulces: anObject
	
	dulces := anObject! !

!Ninio methodsFor: 'as yet unclassified' stamp: ''!
elMasInteractuado
^self interactuados detectMax: [ :unaPersona| self interactuados occurrencesOf: unaPersona  ].! !

!Ninio methodsFor: 'accessing' stamp: ''!
initialize
|interac|
interac :=OrderedCollection new.

self interactuados: interac.! !

!Ninio methodsFor: 'accessing' stamp: ''!
interactuados
	^ interactuados! !

!Ninio methodsFor: 'accessing' stamp: ''!
interactuados: anObject
	interactuados := anObject! !

!Ninio methodsFor: 'accessing' stamp: ''!
recibirDulces: unaCantidad

self dulces: (self dulces + unaCantidad).! !

!Ninio methodsFor: 'accessing' stamp: ''!
traje
	^ traje! !

!Ninio methodsFor: 'accessing' stamp: ''!
traje: anObject
	traje := anObject! !

Object subclass: #Terrorifico
	instanceVariableNames: 'nivelMascara tunica'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Terrorifico class methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 00:56'!
crearCon: mascara tunica: tunica
 |cuentoTerrorifico|
cuentoTerrorifico := Terrorifico new.
cuentoTerrorifico nivelMascara: mascara.
cuentoTerrorifico tunica: tunica.
^cuentoTerrorifico! !

!Terrorifico methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:22'!
nivelMascara
	
	^ nivelMascara! !

!Terrorifico methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:22'!
nivelMascara: anObject
	
	nivelMascara := anObject! !

!Terrorifico methodsFor: 'as yet unclassified' stamp: 'Aldana 10/31/2015 20:24'!
nivelSusto
^(self nivelMascara) + (tunica longitud).! !

Object subclass: #Tierno
	instanceVariableNames: ''
	classVariableNames: 'NivelSusto'
	poolDictionaries: ''
	category: 'Halloween'!

!Tierno class methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 01:12'!
crearCon: nivelSusto
 |unTierno|
unTierno:= Tierno new.
unTierno class nivelSusto: nivelSusto.
^unTierno.! !

!Tierno class methodsFor: 'as yet unclassified' stamp: 'Aldana 10/31/2015 20:30'!
nivelSusto
^NivelSusto.! !

!Tierno class methodsFor: 'as yet unclassified' stamp: 'Aldana 10/31/2015 20:33'!
nivelSusto: unNivel
NivelSusto:= unNivel.! !

!Tierno methodsFor: 'as yet unclassified' stamp: 'Aldana 10/31/2015 20:33'!
nivelSusto
^self class nivelSusto.! !

Object subclass: #Tradicional
	instanceVariableNames: 'tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Tradicional class methodsFor: 'instance creation' stamp: 'Aldana 11/24/2015 00:58'!
crearCon: tipo
 |cuentoTradicional|
cuentoTradicional := Tradicional new.
cuentoTradicional tipo: tipo.
^cuentoTradicional.! !

!Tradicional methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 21:35'!
tipo
	
	^ tipo! !

!Tradicional methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 21:33'!
tipo: anObject
	
	tipo := anObject! !

Object subclass: #Tunica
	instanceVariableNames: 'longitud color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Halloween'!

!Tunica class methodsFor: 'as yet unclassified' stamp: 'Aldana 11/24/2015 00:59'!
crearCon: longitud color: color
 |unaTunica|
unaTunica:= Tunica new.
unaTunica longitud: longitud.
unaTunica color: color.
^unaTunica.! !

!Tunica methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:24'!
color
	
	^ color! !

!Tunica methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:24'!
color: anObject
	
	color := anObject! !

!Tunica methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:24'!
longitud
	
	^ longitud! !

!Tunica methodsFor: 'accessing' stamp: 'Aldana 10/31/2015 20:24'!
longitud: anObject
	
	longitud := anObject! !
